﻿@model eCommerce.Services.Model.Transaction
@using eCommerce.Services.Model.Enums
@{
    ViewBag.Title = "Pagos";
    Layout = "~/Views/Shared/_ListLayout.cshtml";
}


<div class="page-header">
    <h1 class="page-title">Pago</h1>
    <ol class="breadcrumb">
        <li class="active">Crear / Editar</li>
    </ol>
</div>

<div class="page-content">
    <div class="panel">
        <div class="panel-body">
@using (Html.BeginForm("PurchasePaymentUpdate", "PurchasePayments", FormMethod.Post, new { @class = "form-horizontal", @autocomplete = "off" }))
{
            <div class="col-md-12">
                <div id="example">
                    
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Fecha</label>
                            <div class="col-sm-3">
                                <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="icon wb-calendar" aria-hidden="true"></i>
                                    </span>
                                    <input type="text" class="form-control" name="Date" value="@(Model.Date != DateTime.MinValue ? Model.Date.ToShortDateString() : DateTime.Today.ToShortDateString())" data-plugin="datepicker" />
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Cuenta Orígen</label>
                            <div class="col-sm-4">
                                <select class="form-control" name="AccountId" id="AccountId" data-plugin="select2">
                                    @if (ViewData["Accounts"] != null)
                                    {
                                        foreach (var item in (SelectList)ViewData["Accounts"])
                                        {
                                            <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                        }
                                    }
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Moneda:</label>
                            <div class="col-sm-4">
                                <select class="form-control" name="CurrencyId" id="CurrencyId" data-plugin="select2">
                                    <option value="@((int)CurrencyEnum.Peso)" selected="@(Model.CurrencyId == (int)CurrencyEnum.Peso)">Peso</option>
                                    <option value="@((int)CurrencyEnum.Dolar)" selected="@(Model.CurrencyId == (int)CurrencyEnum.Dolar)">Dolar</option>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Monto</label>
                            <div class="col-sm-4">
                                <div class="input-group">
                                    <span class="input-group-addon">$</span>
                                    <input id="Amount" type="text" class="form-control currency" name="Amount" value="@(Model.Amount > 0 ? Model.Amount.ToString() : string.Empty)"
                                           placeholder="Pendiente por pagar: @string.Format("{0:C2}", Model.Purchase.PendingAmountToPay)">
                                </div>
                                <p>Ingresar valores manualmente</p>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Observaciones</label>
                            <div class="col-sm-9">
                                <textarea class="form-control" name="Observations" rows="2">@Model.Observations</textarea>
                            </div>
                        </div>

                        <input type="hidden" name="ChecksIds" id="ChecksIds" value="@Model.ChecksIds" />

                    
                </div>
            </div>
            <div class="row">
                        <div class="col-md-12">
                            <div class="text-right margin-top-20">
                                <button type="button" class="btn btn-outline btn-primary" data-target="#checks" data-toggle="modal" id="addCheckButton">
                                    <i class="icon wb-plus" aria-hidden="true"></i>
                                    <span class="hidden-xs">CHEQUES EN CARTERA</span>
                                </button>
                            </div>
                            <div class="example">
                                <div class="example-body">
                                    <table class="table table-bordered table-hover" id="paymentMethodsChecks">
                                        <thead>
                                            <tr>
                                                <th class="text-center">N° Int</th>
                                                <th>Recibido</th>
                                                <th>N° Cheque</th>
                                                <th>Banco</th>
                                                <th>Monto</th>
                                                <th>Vencimiento</th>
                                                <th>Plazo</th>
                                                <th></th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @if (Model.TransactionId > 1 && Model.PaymentChecks != null)
                                            {
                                                foreach (var check in Model.PaymentChecks)
                                                {
                                                    <tr class="paymentMethodCheck" data-attr-id="@check.CheckId">
                                                        <td class="text-center">@check.CheckId</td>
                                                        <td>@check.RecievedDate.ToShortDateString()</td>
                                                        <td>@check.Number</td>
                                                        <td>@check.Bank.Name</td>
                                                        <td><span class="checkAmount">@check.Amount.ToString()</span></td>
                                                        <td>@check.DueDate.ToShortDateString()</td>
                                                        <td class="daysToDueTd">
                                                        @if (check.DaysToDueDate > 0)
                                                        {
                                                                <p class="positive">@check.DaysToDueDate</p>
                                                            }
                                                            else
                                                            {
                                                                <p class="negative">@check.DaysToDueDate</p>
                                                            }
                                                        <td class="text-center"><i class="icon fa-close removeCheck" aria-hidden="true" data-attr-id='@check.CheckId' onclick="removeCheck(this);"></i></td>
                                                    </tr>
                                                }
                                            }
                                        </tbody>

                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
            <table class="table table-bordered table-hover table-striped" id="totalTable">
                <colgroup>
                    <col class="col-sm-1">
                    <col class="col-sm-1">
                    <col class="col-sm-4">
                    <col class="col-sm-2">
                    <col class="col-sm-2">
                    <col class="col-sm-1">
                </colgroup>
                <thead>
                    <tr></tr>
                </thead>
                <tbody></tbody>
                <tfoot>
                    <tr class="active">
                        <td class="text-right" style="font-weight:bold;" colspan="4">TOTAL</td>
                        <td><span id="poTotal">0</span></td>

                    </tr>
                </tfoot>
            </table>

            <div class="text-right">
                <button type="submit" class="btn btn-primary btn-success" id="btnSave">Grabar</button>
                <button type="button" class="btn btn-default" onclick="window.location.href = '/PurchasePayments?id=@Model.PurchaseId'">Cancelar</button>
                <input type="hidden" name="PurchaseId" id="PurchaseId" value="@Model.PurchaseId" />
                @Html.HiddenFor(model => model.TransactionId)
            </div>
        }
        </div>
    </div>
</div>

<div class="modal fade" id="checks" aria-hidden="false" aria-labelledby="checks"
     role="dialog" tabindex="-1">
    <div class="modal-dialog" style="width: 800px;">
        <form class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
                <h4 class="modal-title" id="exampleFormModalLabel">Cheques en Cartera</h4>
            </div>
            <div class="modal-body">
                @{Html.RenderAction("CheckListPartial");}
                @*@{ Html.RenderPartial("~/Views/Checks/_CheckList.cshtml", Model.Checks); }*@
            </div>
        </form>
    </div>
</div>

@section Scripts {



    <script type="text/javascript">

        (function () {
            $('.form-horizontal').formValidation({
                framework: "bootstrap",
                button: {
                    selector: '#btnSave',
                    disabled: 'disabled'
                },
                icon: null,
                fields: {
                    AccountId: {
                        validators: {
                            notEmpty: {
                                message: 'El campo es requerido.'
                            }
                        }
                    },
                    PaymentMethod: {
                        validators: {
                            notEmpty: {
                                message: 'El campo es requerido.'
                            }
                        }
                    },
                    Date: {
                        validators: {
                            notEmpty: {
                                message: 'El campo es requerido.'
                            }
                        }
                    },
                    Amount: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Monto es requerido.'
                            }
                        }
                    }
                }
            });
        })();

        $(document).ready(function () {
            $(".currency").number(true, 2, ',', '.');
            calculatePaymentOrderTotal();
        });

        $("#btnSave").click(function (e) {
            e.preventDefault();

            $('form')[0].submit();
        });

        @if (Model.Checks != null)
        {
            foreach (var check in Model.Checks)
            {
                <text>
            $('#checksTable tr[data-attr-id="' + @check.CheckId + '"]').hide();
                </text>
            }
        }

        $('#addCheckButton').click(function (e) {
            $('.deliveredToTh, .deliveredToTd, .actionsTh, .actionsTd').hide();
        });

        $('#checksTable tr[data-attr-id]').click(function () {
            var checksTable = $('#checksTable').dataTable();
            var rowPosition = checksTable.fnGetPosition(this);
            var rowData = checksTable.fnGetData(rowPosition);
            addCheckToPaymentMethods(rowData);
            $(this).hide();
            $('#checks').modal('hide');
        });

        function addCheckToPaymentMethods(check) {
            var checkId = check[0];
            var id = createColumn(check[0], true);
            var received = createColumn(check[1]);
            var customer = createColumn(check[2]);
            var checkNumber = createColumn(check[3]);
            var bank = createColumn(check[4]);
            var amount = '<td><span class="checkAmount">' + check[5] + '</span></td>';
            var dueDate = createColumn(check[6]);
            var plazo = createColumn(check[7]);
            var removeCheck = '<td class="text-center"><i class="icon fa-close removeCheck" aria-hidden="true" data-attr-id=' + checkId + ' onclick="removeCheck(this);"></i></td>';

            $('#paymentMethodsChecks > tbody:last-child').append('<tr class="paymentMethodCheck" hidden="hidden" data-attr-id=' + checkId + '>' + id + received + checkNumber + bank + amount + dueDate + plazo + removeCheck + '</tr>');
            $('.paymentMethodCheck[data-attr-id="' + checkId + '"]').fadeIn();
            updateChecksIds();
            calculatePaymentOrderTotal();
        }

        function removeCheck(check)
        {
            var checkId = $(check).data('attr-id');
            $('#checksTable tr[data-attr-id="' + checkId + '"]').show();
            var checkRow = $(check).parent().parent();

            checkRow.fadeOut("slow", function ()
            {
                checkRow.remove();
                calculatePaymentOrderTotal();
                updateChecksIds();
            });
        }

        function updateChecksIds()
        {
            var checkIds = $('#ChecksIds');
            var checkIdsArray = [];
            $('.paymentMethodCheck').each(function (c) {
                checkIdsArray.push($(this).data('attr-id'));
            });
            checkIds.val(checkIdsArray.join(','));
        }

        function createColumn(data, center) {
            if (center != undefined) {
                return '<td class="text-center">' + data + '</td>';
            }
            else {
                return '<td>' + data + '</td>';
            }
        }

        function calculatePaymentOrderTotal() {
            var sum = 0;

            //$('.sumMoney').each(function () {
            //    sum += Number($(this).text().replace('$','').replace(',', '.'));
            //});

            //sum += Number($('#Amount').val().replace(',', '.'));

            $('.checkAmount').each(function () {
                sum += Number($(this).text().split('$').join('').split('.').join('').replace(',', '.'));
            });

            $('#poTotal').text(sum.toLocaleString("es-AR", { style: "currency", currency: "ARS" }));
        }

        /*function removeCheck(check, rowNumber)
        {
            var checkId = $(check).data('attr-id');
            var checkRow = $(check).parent().parent();

            $("input[name*='Checks[" + rowNumber + "].Active']").val(false);

            checkRow.fadeOut("slow", function () {
                checkRow.remove();
                
                calculateChargeTotal();
            });
        }*/

    </script>


}

